"""
Post mortem crash handling that is actually useful...
(C) Copyright 2007 Hamster Republic Productions
"""

########################################################################
import sys
import traceback
import linecache
import time

#TODO: dump stats on installed modules - http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/440501
def _ExtractExceptionLine(trace):
    frame = trace.tb_frame
    lineno = trace.tb_lineno
    code = frame.f_code
    filename = code.co_filename
    return linecache.getline(filename, lineno)

def WriteXMLCrashReport(file, type, value, trace):
    file.write("<CrashReport time="+time.strftime("%Y-%m-%dT%H:%M:%SZ", time.gmtime())+">")
    file.write(" <Exception>")
    file.write("  <Type>"+str(type)+"<Type/>")
    file.write("  <Value>"+str(value)+"<Value/>")
    file.write(" <\Exception>")
    file.write(" <Traceback>")
    #TODO: put in the traceback, with locals
    file.write(" <\Traceback>")
    file.write("<\CrashReport>")
    
def Autopsy(type, value, trace):
    sys.excepthook = __old_excepthook
    #TODO: make some crash dump file
    try:
        sys.stderr.write("coroner caught exception:\n")
        sys.stderr.write("-------------------------\n")
        final_trace = trace
        while final_trace.tb_next:
            final_trace = final_trace.tb_next
        failed_line = _ExtractExceptionLine(final_trace)
        sys.stderr.write(str(value) + " when executing:\n")
        sys.stderr.write(failed_line)
        if (type == ImportError):
            if failed_line.find("wx.") != -1 and str(value).find("wx.") == -1:
                import wx
                sys.stderr.write("installed wx version:"+str(wx.VERSION)+"\n")
            sys.stderr.write("module search paths: "+str(sys.path)+"\n")
        else:
            crash_frame = final_trace.tb_frame
            sys.stderr.write("locals: "+str(crash_frame.f_locals)+"\n")
        sys.stderr.write("-------------------------\n")
        traceback.print_exception(type, value, trace)
    except:
        internal_type, internal_value, internal_trace = sys.exc_info()
        sys.stderr.write("Error when Coroner was performing autopsy:\n")
        sys.stderr.write(str(internal_value) + "\n")
        traceback.print_exception(internal_type, internal_value, internal_trace)
        
        sys.stderr.write("\nOriginal Error:\n")
        __old_excepthook(type, value, trace)

__old_excepthook = sys.excepthook
sys.excepthook = Autopsy

if __name__ == "__main__":
    def DivideByZero():
        zero_variable = 0
        dividebyzero = 1/zero_variable
        
    def wxImportError():
        local_var = 1
        import wx.NotAModule

    def AttributeError():
        bob = object()
        bob.mispeeling = 5
        a = bob.mispelling

    try:
        AttributeError()
    except:
        Autopsy(*sys.exc_info())
    try:
        DivideByZero()
    except:
        Autopsy(*sys.exc_info())
    try:
        wxImportError()
    except:
        Autopsy(*sys.exc_info())
    