"""
a module to register things for being presented in the editor
this makes it so the editor code doesn't need to be aware of everything
(C) Copyright 2007 Hamster Republic Productions
"""

########################################################################
class DebugImageSource(object):
    def __init__(self, count_func, image_func, info_func):
        self.GetNumItems = count_func
        self.GetImage = image_func
        self.GetInfo = info_func

_ImageSources = {}

def RegisterImageSource(name, count_func, image_func, info_func):
    _ImageSources[name] = DebugImageSource(count_func, image_func, info_func)

def GetImageSources():
    sources = {}
    for name in _ImageSources:
        source = _ImageSources[name]
        if source.GetNumItems() > 0:
            sources[name] = source
    return sources
            