"""
Image Loader
(C) Copyright 2004 Hamster Republic Productions
"""

########################################################################
import pygame.mixer
import pygame.image
from motherhamster.cheekpouches import *
from motherhamster.enums import Enum

########################################################################
_EstimatedSoundMemory = 0

def EstimateSoundMemory():
    global _EstimatedSoundMemory
    return _EstimatedSoundMemory

def CountSoundMemory(Sound):
    global _EstimatedSoundMemory
    size = Sound.get_length()*22050*2
    _EstimatedSoundMemory += size
    return size

def SubtractSoundMemory(size):
    global _EstimatedSoundMemory
    _EstimatedSoundMemory -= size

_InitializedPlayback = False 
def _InitializeSoundPlayback():
    global _InitializedPlayback
    if not _InitializedPlayback:
        pygame.mixer.set_num_channels(32)
        pygame.mixer.set_reserved(2)
        _InitializedPlayback = True
    
########################################################################
class SoundAsset(AssetBase):
    """a python object representation of a sound asset"""

    def __init__(self, file_like_object):
        self.__rawsound = pygame.mixer.Sound(file_like_object)
        self._memory_estimate = CountSoundMemory(self.__rawsound)

    def __del__(self):
        global SubtractSoundMemory
        if (SubtractSoundMemory != None):
            SubtractSoundMemory(self._memory_estimate)
    
    def play(self):
        global _InitializedPlayback, _InitializeSoundPlayback
        if not _InitializedPlayback:
            _InitializeSoundPlayback()
            
        channel = self.__rawsound.play()
        return channel

    def set_as_music(self):
        global _InitializedPlayback, _InitializeSoundPlayback
        if not _InitializedPlayback:
            _InitializeSoundPlayback()

        channel = pygame.mixer.Channel(0)
        channel.play(self.__rawsound, -1)
        
########################################################################
class _SoundPouch(GenericAssetPouch):
    """loads sound asets"""

    def __init__(self):
        GenericAssetPouch.__init__(self, SoundAsset)
        self._asset_paths = None

    def AssetExtensions(self):
        return [".ogg", ".wav"]

    def _load(self, asset_path):
        """loads an asset using pickle for the data part and also loads some image part..."""
        path = self.GetAssetPathForID(asset_path)
        if (path):
            dish = GetFoodDish(path.root)
            asset = SoundAsset(dish.open(path.filepath, "rb"))
            return asset
        return None

########################################################################

pouch = _SoundPouch()
RegisterPouch(pouch)

if __name__ == "__main__":
    #TODO: imagepouch unit tests
    pass
